Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3050)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3051)
@@ -4481,9 +4466,14 @@
 ! Description:
 ! ------------
-!> Reads a 4D float variable from file. Note, in constrast to 3D versions,
-!> dimensions are already inquired and passed so that they are known here.
-!------------------------------------------------------------------------------!
-    SUBROUTINE get_variable_4d_real( id, variable_name, i, j, var, n3, n4 )
-
+!> Reads a 3D float variables from dynamic driver, such as time-dependent xy-, 
+!> xz- or yz-boundary data as well as 3D initialization data. Please note, 
+!> the passed arguments are start indices and number of elements in each 
+!> dimension, which is in contrast to the other 3d versions where start- and 
+!> end indices are passed. The different handling of 3D dynamic variables is 
+!> due to its asymmetry for the u- and v component.
+!------------------------------------------------------------------------------!
+    SUBROUTINE get_variable_3d_real_dynamic( id, variable_name, var,           &
+                            i1s, i2s, i3s, count_1, count_2, count_3, dynamic)
+                                
        USE indices
        USE pegrid
@@ -4493,69 +4483,69 @@
        CHARACTER(LEN=*)              ::  variable_name   !< variable name
 
-       INTEGER(iwp), INTENT(IN)      ::  i               !< index along x direction
+       LOGICAL                       ::  dynamic         !< additional flag just used to select correct overloaded routine from interface block 
+       
+       INTEGER(iwp)                  ::  count_1         !< number of elements to be read along 1st dimension (with respect to file)
+       INTEGER(iwp)                  ::  count_2         !< number of elements to be read along 2nd dimension (with respect to file)
+       INTEGER(iwp)                  ::  count_3         !< number of elements to be read along 3rd dimension (with respect to file)
+       INTEGER(iwp)                  ::  i1              !< running index along 1st dimension on file
+       INTEGER(iwp)                  ::  i1s             !< start index for subdomain input along 1st dimension (with respect to file)
+       INTEGER(iwp)                  ::  i2              !< running index along 2nd dimension on file       
+       INTEGER(iwp)                  ::  i2s             !< start index for subdomain input along 2nd dimension (with respect to file)
+       INTEGER(iwp)                  ::  i3              !< running index along 3rd dimension on file 
+       INTEGER(iwp)                  ::  i3s             !< start index of 3rd dimension, in dynamic file this is either time (2D boundary) or z (3D)
        INTEGER(iwp), INTENT(IN)      ::  id              !< file id
        INTEGER(iwp)                  ::  id_var          !< variable id
-       INTEGER(iwp), INTENT(IN)      ::  j               !< index along y direction
-       INTEGER(iwp), INTENT(IN)      ::  n3              !< number of data-points along 3rd dimension
-       INTEGER(iwp), INTENT(IN)      ::  n4              !< number of data-points along 4th dimension
-
-       INTEGER(iwp), DIMENSION(3)    ::  id_dim
-
-       REAL(wp), DIMENSION(:,:), INTENT(INOUT) ::  var     !< variable to be read
+       INTEGER(iwp)                  ::  lb1             !< lower bound of 1st dimension (with respect to file)
+       INTEGER(iwp)                  ::  lb2             !< lower bound of 2nd dimension (with respect to file)
+       INTEGER(iwp)                  ::  lb3             !< lower bound of 3rd dimension (with respect to file)
+       INTEGER(iwp)                  ::  ub1             !< upper bound of 1st dimension (with respect to file)
+       INTEGER(iwp)                  ::  ub2             !< upper bound of 2nd dimension (with respect to file)
+       INTEGER(iwp)                  ::  ub3             !< upper bound of 3rd dimension (with respect to file)
+
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  tmp !< temporary variable to read data from file according
+                                                         !< to its reverse memory access
+       
+       REAL(wp), DIMENSION(:,:,:), INTENT(INOUT) ::  var !< input variable
+       
 #if defined( __netcdf )
-
 !
 !--    Inquire variable id
        nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
 !
+!--    Check for collective read-operation and set respective NetCDF flags if
+!--    required. 
+       IF ( collective_read )  THEN
+          nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+       ENDIF    
+!
+!--    Allocate temporary variable according to memory access on file. 
+!--    Therefore, determine dimension bounds of input array. 
+       lb1 = LBOUND(var,3)
+       ub1 = UBOUND(var,3)
+       lb2 = LBOUND(var,2)
+       ub2 = UBOUND(var,2)
+       lb3 = LBOUND(var,1)
+       ub3 = UBOUND(var,1)
+       ALLOCATE( tmp(lb1:ub1,lb2:ub2,lb3:ub3) )
+!
 !--    Get variable
-       nc_stat = NF90_GET_VAR( id, id_var, var,                                &
-                               start = (/ i+1, j+1, 1, 1 /),                   &
-                               count = (/ 1, 1, n3, n4 /) )
-
-       CALL handle_error( 'get_variable_4d_real', 533 )
+       nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                               start = (/ i1s,     i2s,     i3s /),            &
+                               count = (/ count_1, count_2, count_3 /) )
+
+       CALL handle_error( 'get_variable_3d_real_dynamic', 536, variable_name )
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+       DO  i3 = lb3, ub3
+          DO i2 = lb2, ub2
+             DO  i1 = lb1, ub1
+                var(i3,i2,i1) = tmp(i1,i2,i3)
+             ENDDO
+          ENDDO
+       ENDDO
+       
+       DEALLOCATE( tmp )       
 #endif
-    END SUBROUTINE get_variable_4d_real
-
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Reads a 3D float variable at left, right, north, south and top boundaries.
-!------------------------------------------------------------------------------!
-    SUBROUTINE get_variable_bc( id, variable_name, t_start,                    &
-                                i2_s, count_2, i3_s, count_3,  var )
-
-       USE indices
-       USE pegrid
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*)              ::  variable_name   !< variable name
-
-       INTEGER(iwp)                  ::  count_2         !< number of elements in second dimension
-       INTEGER(iwp)                  ::  count_3         !< number of elements in third dimension (usually 1)
-       INTEGER(iwp)                  ::  i2_s            !< start index of second dimension
-       INTEGER(iwp)                  ::  i3_s            !< start index of third dimension
-       INTEGER(iwp), INTENT(IN)      ::  id              !< file id
-       INTEGER(iwp)                  ::  id_var          !< variable id
-       INTEGER(iwp)                  ::  t_start         !< start index at time dimension with respect to netcdf convention
-
-       REAL(wp), DIMENSION(:), INTENT(INOUT) ::  var     !< input variable
-#if defined( __netcdf )
-
-!
-!--    Inquire variable id
-       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-!
-!--    Get variable
-       nc_stat = NF90_GET_VAR( id, id_var, var,                              &
-                               start = (/ i3_s, i2_s, t_start /),            &
-                               count = (/ count_3, count_2, 1 /) )
-
-       CALL handle_error( 'get_variable_bc', 532 )
-#endif
-    END SUBROUTINE get_variable_bc
+    END SUBROUTINE get_variable_3d_real_dynamic
 
 
@@ -4578,5 +4568,5 @@
 
        nc_stat = NF90_INQUIRE( id, NVARIABLES = num_vars )
-       CALL handle_error( 'inquire_num_variables', 534 )
+       CALL handle_error( 'inquire_num_variables', 537 )
 
 #endif
@@ -4605,9 +4595,9 @@
        ALLOCATE( varids(1:SIZE(var_names)) )
        nc_stat = NF90_INQ_VARIDS( id, NVARS = num_vars, VARIDS = varids )
-       CALL handle_error( 'inquire_variable_names', 535 )
+       CALL handle_error( 'inquire_variable_names', 538 )
 
        DO  i = 1, SIZE(var_names)
           nc_stat = NF90_INQUIRE_VARIABLE( id, varids(i), NAME = var_names(i) )
-          CALL handle_error( 'inquire_variable_names', 535 )
+          CALL handle_error( 'inquire_variable_names', 538 )
        ENDDO
 
@@ -4621,5 +4611,5 @@
 !> Prints out a text message corresponding to the current status.
 !------------------------------------------------------------------------------!
-    SUBROUTINE handle_error( routine_name, errno )
+    SUBROUTINE handle_error( routine_name, errno, name )
 
        USE control_parameters,                                                 &
@@ -4630,12 +4620,20 @@
        CHARACTER(LEN=6) ::  message_identifier
        CHARACTER(LEN=*) ::  routine_name
+       CHARACTER(LEN=*), OPTIONAL ::  name
 
        INTEGER(iwp) ::  errno
 #if defined( __netcdf )
-
+       
        IF ( nc_stat /= NF90_NOERR )  THEN
 
           WRITE( message_identifier, '(''NC'',I4.4)' )  errno
-          message_string = TRIM( NF90_STRERROR( nc_stat ) )
+          
+          IF ( PRESENT( name ) )  THEN
+             message_string = "Problem reading attribute/variable - " //       &
+                              TRIM(name) // ": " //                            &
+                              TRIM( NF90_STRERROR( nc_stat ) )
+          ELSE
+             message_string = TRIM( NF90_STRERROR( nc_stat ) )
+          ENDIF
 
           CALL message( routine_name, message_identifier, 2, 2, 0, 6, 1 )
Index: /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 3050)
+++ /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 3051)
@@ -25,8 +25,8 @@
 ! -----------------
 ! $Id$
-! Error messages revised
+! Bugfix in calculation of initial Reynolds-stress tensor.
 ! 
 ! 3045 2018-05-28 07:55:41Z Giersch
-! Error message revised
+! Error messages revised
 ! 
 ! 3044 2018-05-25 10:59:41Z gronemeier
@@ -718,8 +718,6 @@
        IF ( a22(k) > 0.0_wp )  THEN
           a22(k) = SQRT( a22(k) )
-          a32(k) = ( r32(k) - a21(k) * a31(k) ) / a22(k)
        ELSE
           a22(k) = 0.0_wp
-          a32(k) = 0.0_wp
        ENDIF
 
